#pragma once

#include "../main.h"

struct SyscallImplementation final : Implementation {
    int main(int argc, char *argv[]) override;
    void memory_writer(uint32_t guest_addr, const void *data, uint32_t size) const override;
    void handle_syscall(uint32_t arg1, uint32_t arg2) const;
    static SyscallImplementation *instance;
};