#pragma once

#include <cstdint>

#include "trampoline.h"

struct Implementation {
    virtual ~Implementation() = default;
    virtual int main(int argc, char *argv[]) = 0;
    virtual void memory_writer(uint32_t guest_addr, const void *data, uint32_t size) const = 0;
    Trampoline trampoline;
};